/*
(c) Copyright 1994 HEWLETT-PACKARD COMPANY

To anyone who acknowledges that this file is provided 
"AS IS" without any express or implied warranty:
permission to use, copy, modify, and distribute this 
file for any purpose is hereby granted without fee, 
provided that the above copyright notice and this 
notice appears in all copies, and that the name of 
Hewlett-Packard Company not be used in advertising or 
publicity pertaining to distribution of the software 
without specific, written prior permission.  Hewlett-
Packard Company makes no representations about the 
suitability of this software for any purpose.
*/

#include "xscmlibint.h"


int XscmRender24Bit (RENDER_PARS)
    RENDER_PARS_FULL
{
unsigned long     pixel, *pDst;
int               nPixelsM1;
unsigned char    *pSrc;
int               red, green, blue;
int               redShift, greenShift, blueShift;

    redShift = pInfo->redShift;
    greenShift = pInfo->greenShift;
    blueShift = pInfo->blueShift;

    while (height-- > 0) {
        pSrc = src;
        src += srcRowBytes;
        pDst = (unsigned long *)dst;
        dst += dstRowBytes;
        nPixelsM1 = width - 1;
        do {
            if (pRed) {
                pixel = *pSrc++;
                red   = pRed[pixel] >> 8;
                green = pGreen[pixel] >> 8;
                blue  = pBlue[pixel] >> 8;
	        }
            else {
                red   = *pSrc++;
                green = *pSrc++;
                blue  = *pSrc++;
	        }
            pixel = (red << redShift) | (green << greenShift) 
                                      | (blue << blueShift);
            *pDst++ = pixel;
            } while (--nPixelsM1 >= 0);
        }
    return TRUE;
}


DISPLAY_FUNCTION (XscmDisplay24Bit, XscmRender24Bit)

