/*
(c) Copyright 1994 HEWLETT-PACKARD COMPANY

To anyone who acknowledges that this file is provided 
"AS IS" without any express or implied warranty:
permission to use, copy, modify, and distribute this 
file for any purpose is hereby granted without fee, 
provided that the above copyright notice and this 
notice appears in all copies, and that the name of 
Hewlett-Packard Company not be used in advertising or 
publicity pertaining to distribution of the software 
without specific, written prior permission.  Hewlett-
Packard Company makes no representations about the 
suitability of this software for any purpose.
*/



#include "xscmlibint.h"


int XscmRGBToGray (RENDER_PARS)
    RENDER_PARS_FULL
{
int                red, green, blue, i;
int                basePixel = pInfo->basePixel;
long               pixel;
unsigned char     *pSrc, *pDst;
long               nPixelsM1;
static int         R[256], G[256], B[256];
static int         tableInited = 0;

        /*  Init tables, index by R/G/B, which effectively mul each component
            (0..255) by the NTSC formula: 0.30 * R + 0.587 * G + 0.114 * B,
            except that each value is * 65536 for extra accuracy: the result is
            shifted right by 16 before storing.
            Note also that if R/G/B are all = 255
            the result is still <= 255 after the shift right.
        */
    if (!tableInited) {
        tableInited = 1;
        for (i = 0; i < 256; i++) {
            R[i] = 19661 * i;
            G[i] = 38469 * i;
            B[i] = 7471 * i;
            }
        }

    while (height-- > 0) {
        pSrc = src;
        src += srcRowBytes;
        pDst = dst;
        dst += dstRowBytes;
        nPixelsM1 = width - 1;

        do {
            if (pRed) {
                pixel = *pSrc++;
                red   = pRed[pixel] >> 8;
                green = pGreen[pixel] >> 8;
                blue  = pBlue[pixel] >> 8;
	        }
            else {
                red   = *pSrc++;
                green = *pSrc++;
                blue  = *pSrc++;
	        }
            pixel = R[red] + G[green] + B[blue];
            pixel >>= (16 + 3);
            pixel += basePixel;
            *pDst++ = (unsigned char)pixel;
            } while (--nPixelsM1 >= 0);
        }
    return TRUE;
}


DISPLAY_FUNCTION (XscmDisplayGray, XscmRGBToGray)
