.TH xscm
.SH NAME
Xscm - X Standard Colour Map.
.SH SYNOPSIS
\fBxscm [-help] [-display <dsp>] [-default] [-best] [-gray] [-all] [-replace] [-delete] [-list]\fR
.SH DESCRIPTION
.PP
Xscm has been developed to help foster the use of standard
colormaps within X applications, middleware, vendor offerings and future
standardization efforts.  For more information on X standard colormaps see
(starting at page 220):
.DS
    "Xlib Programming Manual for Version 11, Release 4" by Adrian Nye
    (c) 1990 O'Reilly & Associates, Inc.
    ISBN 0-937175-11-0
.DE
.SH OPTIONS
.PP
.B \-help
Print s help and exits.
.PP
.B \-display <dsp>
Use the X server named <dsp>
.PP
.B \-default
Create XA_RGB_DEFAULT_MAP in the default colormap.  Uses up to 128 colormap slots.
.PP
.B \-gray
Create XA_RGB_GRAY_MAP in the default colormap.  Uses up to 32 colormap slots.
.PP
.B \-best
Create XA_RGB_BEST_MAP, only if a TrueColor or DirectColor visual exists.
.PP
.B \-nocr
Disables use of Color Recovery map; default is to use it for best map if present.
.PP
.B \-all
Equivalent to '-default -gray -best'.
.PP
.B \-replace
Replace the standard colormap if it already exists; default is to not replace it.
.PP
.B \-delete
Delete rather than create the requeste standard colormaps.
.PP
.B \-list
List info on the standard colormaps found after all other operations are done.
.SH EXAMPLE
.B xscm -all -replace
.PP
xscm creates, lists or deletes standard colormaps as used by
XGetRGBColormaps() on all screens.
.SH AVAILABILITY:
You may obtain the latest realease of 
.I xscm 
source via anonymous ftp from internet host 
.I hpcvaaz.cv.hp.com
in directory
.I pub/xscm
.SH AUTHOR
Peter Kaczowka (kaczowka@ch.hp.com)
.SH MAN PAGE
s4adj@csc.liv.ac.uk

